Index: EcnlProtoTool/trunk/asp3_dcre/kernel/kernel.trb
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/kernel/kernel.trb	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/kernel/kernel.trb	(revision 429)
@@ -6,5 +6,5 @@
 # 
 #   Copyright (C) 2015 by FUJI SOFT INCORPORATED, JAPAN
-#   Copyright (C) 2015,2016 by Embedded and Real-Time Systems Laboratory
+#   Copyright (C) 2015-2019 by Embedded and Real-Time Systems Laboratory
 #               Graduate School of Information Science, Nagoya Univ., JAPAN
 # 
@@ -38,5 +38,5 @@
 #   の責任を負わない．
 # 
-#   $Id$
+#   $Id: kernel.trb 1167 2019-02-03 17:06:17Z ertl-hiro $
 # 
 
@@ -75,10 +75,8 @@
 
 #
-#  インクルードディレクティブ（#include）
+#  インクルードディレクティブ（#include）の生成
 #
 $kernelCfgC.comment_header("Include Directives")
-$includeFiles.each do |file|
-  $kernelCfgC.add("#include #{file}")
-end
+GenerateIncludes($kernelCfgC)
 $kernelCfgC.add()
 
@@ -91,5 +89,5 @@
   def AllocStack(stack, size)
     # 大きい方に丸めたサイズで確保する［NGKI1050］［NGKI3220］
-    $kernelCfgC.add("/*static*/ STK_T #{stack}[COUNT_STK_T(#{size})];")
+    $kernelCfgC.add("static STK_T #{stack}[COUNT_STK_T(#{size})];")
     return("ROUND_STK_T(#{size})")
   end
@@ -107,5 +105,7 @@
     @OBJ_S = obj_s.tr("a-z", "A-Z")
     @objid = (obj + "id").to_sym
+    @noobj = ("no" + obj).to_sym
     @api = "CRE_#{@OBJ}".to_sym
+    @aidapi = "AID_#{@OBJ}".to_sym
     @inibList = { "#{@OBJ_S}INIB" => "a#{@obj_s}inib_table"}
   end
@@ -114,6 +114,6 @@
     # AID_@OBJの処理
     numAutoObjid = 0
-    $cfgData["AID_#{@OBJ}".to_sym].each do |key, params|
-      numAutoObjid += params["no#{@obj}".to_sym]
+    $cfgData[@aidapi].each do |_, params|
+      numAutoObjid += params[@noobj]
     end
     numObjid = $cfgData[@api].size + numAutoObjid
@@ -123,5 +123,5 @@
 
     # オブジェクトのID番号のマクロ定義の生成
-    $cfgData[@api].sort.each do |key, params|
+    $cfgData[@api].sort.each do |_, params|
       $kernelCfgH.add("#define #{params[@objid]}\t#{params[@objid].val}")
     end
@@ -130,5 +130,5 @@
     # オブジェクトのID番号を保持する変数
     if $USE_EXTERNAL_ID
-      $cfgData[@api].sort.each do |key, params|
+      $cfgData[@api].sort.each do |_, params|
         $kernelCfgC.add("const ID #{params[@objid]}_id" \
 										" = #{params[@objid].val};")
@@ -203,5 +203,5 @@
   nfymode1 = nfymode & 0x0f
   nfymode2 = nfymode & ~0x0f
-  par1 = params[:par1]
+  # par1 = params[:par1]
   par2 = params[:par2]
 
@@ -232,5 +232,5 @@
     error_api(params, "too many parameters for nfymode `#{nfymode}' " \
 											"in %apiname of %#{objid}")
-  elsif nfymode == $TNFY_HANDLER
+  elsif nfymode1 == $TNFY_HANDLER && nfymode2 == 0		#［NGKI3721］
     # タイムイベントハンドラの呼出し
     funcname = "(NFYHDR)(#{par2})"
@@ -269,8 +269,8 @@
 
     # イベント通知処理の処理
-    if nfymode1 == $TNFY_SETVAR && nfymode2 == 0
+    if nfymode1 == $TNFY_SETVAR && nfymode2 == 0		#［NGKI3721］
       # 変数の設定
       $kernelCfgC.add("\t*((intptr_t *) exinf) = (#{par2});")
-    elsif nfymode1 == $TNFY_INCVAR && nfymode2 == 0
+    elsif nfymode1 == $TNFY_INCVAR && nfymode2 == 0		#［NGKI3721］
       # 変数のインクリメント
       $kernelCfgC.add("\t(void) loc_cpu();")
@@ -293,11 +293,11 @@
       $kernelCfgC.add("\t#{errorCode}psnd_dtq(((ID) exinf), #{par2});")
     else
+      # nfymodeの値が正しくない場合（E_PAR）［NGKI3730］
       error_illegal_id("E_PAR", params, :nfymode, objid)
     end
-			
+
     if nfymode2 != 0
       # エラー通知処理の処理
       $kernelCfgC.add("\tif (ercd != E_OK) {")
-
 
       if nfymode2 == $TENFY_SETVAR
@@ -326,4 +326,5 @@
 													" (intptr_t) ercd);")
       else
+        # nfymodeの値が正しくない場合（E_PAR）［NGKI3730］
         error_illegal_id("E_PAR", params, :nfymode, objid)
       end
@@ -360,5 +361,5 @@
 if $cfgData[:DEF_ICS].size == 0
   # DEF_ICSがない場合のデフォルト値の設定
-  if $DEFAULT_ISTK.nil?
+  if !defined?($DEFAULT_ISTK)
     # スタック領域の自動割付け
     istksz = AllocStack("_kernel_istack", "DEFAULT_ISTKSZ")
@@ -369,5 +370,5 @@
   end
 else
-  # 静的API「DEF_ICS」が複数ある（E_OBJ）［NGKI3216］
+  # 静的API「DEF_ICS」が複数ある場合（E_OBJ）［NGKI3216］
   if $cfgData[:DEF_ICS].size > 1
     error("E_OBJ: too many DEF_ICS")
@@ -375,27 +376,27 @@
 
   # DEF_ICSがある場合の処理
-  params = $cfgData[:DEF_ICS][1]
+  params0 = $cfgData[:DEF_ICS][1]
 
   # パラメータが省略された時のデフォルト値の設定
-  params[:istk] ||= "NULL"
+  params0[:istk] ||= "NULL"
 
   # istkszがターゲット定義の最小値（TARGET_MIN_ISTKSZ，未定義の場合は1）
   # よりも小さい場合（E_PAR）［NGKI3254］
-  if params[:istksz] < $TARGET_MIN_ISTKSZ
-    error_wrong("E_PAR", params, :istksz, "too small")
-  end
-
-  if params[:istk] == "NULL"
+  if params0[:istksz] < $TARGET_MIN_ISTKSZ
+    error_wrong("E_PAR", params0, :istksz, "too small")
+  end
+
+  if params0[:istk] == "NULL"
     # スタック領域の自動割付け
-    istksz = AllocStack("_kernel_istack", params[:istksz])
+    istksz = AllocStack("_kernel_istack", params0[:istksz])
     istk = "_kernel_istack"
   else
-    # istkszがスタック領域のサイズとして正しくない場合（E_PAR）［NGKI3222］
-    if (params[:istksz] & ($CHECK_STKSZ_ALIGN - 1)) != 0
-      error_wrong("E_PAR", params, :istksz, "not aligned")
-    end
-
-    istksz = "(#{params[:istksz]})"
-    istk = "(void *)(#{params[:istk]})"
+    # istkszがターゲット定義の制約に合致しない場合（E_PAR）［NGKI3222］
+    if (params0[:istksz] & ($CHECK_STKSZ_ALIGN - 1)) != 0
+      error_wrong("E_PAR", params0, :istksz, "not aligned")
+    end
+
+    istksz = "(#{params0[:istksz]})"
+    istk = "(void *)(#{params0[:istk]})"
   end
 end
@@ -411,50 +412,49 @@
 
 #
-#  カーネルが割り付けるメモリ領域
-#
-$kernelCfgC.comment_header("Memory Area Allocated by Kernel")
-
-if $cfgData[:DEF_KMM].size == 0
-  # DEF_KMMがない場合のデフォルト値の設定
-  kmmsz = "0"
-  kmm = "NULL"
+#  カーネルメモリプール領域
+#
+$kernelCfgC.comment_header("Kernel Memory Pool Area")
+
+if $cfgData[:DEF_MPK].size == 0
+  # DEF_MPKがない場合のデフォルト値の設定
+  mpksz = "0"
+  mpk = "NULL"
 else
-  # 静的API「DEF_KMM」が複数ある（E_OBJ）
-  if ($cfgData[:DEF_KMM].size > 1)
-    error("E_OBJ: too many DEF_KMM")
-  end
-
-  # DEF_KMMがある場合の処理
-  params = $cfgData[:DEF_KMM][1]
+  # 静的API「DEF_MPK」が複数ある（E_OBJ）［NGKI5073］
+  if ($cfgData[:DEF_MPK].size > 1)
+    error("E_OBJ: too many DEF_MPK")
+  end
+
+  # DEF_MPKがある場合の処理
+  params0 = $cfgData[:DEF_MPK][1]
 
   # パラメータが省略された時のデフォルト値の設定
-  params[:kmm] ||= "NULL"
-
-  # kmmszが0の場合（E_PAR）
-  if params[:kmmsz] == 0
-    error_wrong("E_PAR", params, :kmmsz, "zero")
-  end
-
-  if params[:kmm] == "NULL"
-    # カーネルが割り付けるメモリ領域の自動割付け
-    $kernelCfgC.add("static MB_T _kernel_memory" \
-					"[TOPPERS_COUNT_SZ(#{params[:kmmsz]}, sizeof(MB_T))];")
-    kmmsz = "TOPPERS_ROUND_SZ(#{params[:kmmsz]}, sizeof(MB_T))"
-    kmm = "_kernel_memory"
+  params0[:mpk] ||= "NULL"
+
+  # mpkszが0の場合（E_PAR）［NGKI5071］
+  if params0[:mpksz] == 0
+    error_wrong("E_PAR", params0, :mpksz, "zero")
+  end
+
+  if params0[:mpk] == "NULL"
+    # カーネルメモリプール領域の自動割付け
+    $kernelCfgC.add("static MB_T _kernel_memory_pool" \
+					"[COUNT_MB_T(#{params0[:mpksz]})];")
+    mpksz = "ROUND_MB_T(#{params0[:mpksz]})"
+    mpk = "_kernel_memory_pool"
   else
-    # kmmszがカーネルが割り付けるメモリ領域のサイズとして正しくない場合
-    # （E_PAR）
-    if (params[:kmmsz] & ($CHECK_MB_ALIGN - 1)) != 0
-      error_wrong("E_PAR", params, :kmmsz, "not aligned")
-    end
-
-    kmmsz = "(#{params[:kmmsz]})"
-    kmm = "(void *)(#{params[:kmm]})"
+    # mpkszがターゲット定義の制約に合致しない場合（E_PAR）［NGKI5083］
+    if (params0[:mpksz] & ($CHECK_MB_ALIGN - 1)) != 0
+      error_wrong("E_PAR", params0, :mpksz, "not aligned")
+    end
+
+    mpksz = "(#{params0[:mpksz]})"
+    mpk = "(void *)(#{params0[:mpk]})"
   end
 end
 
 $kernelCfgC.add(<<EOS)
-const size_t _kernel_kmmsz = #{kmmsz};
-MB_T *const _kernel_kmm = #{kmm};
+const size_t _kernel_mpksz = #{mpksz};
+MB_T *const _kernel_mpk = #{mpk};
 EOS
 
@@ -484,9 +484,14 @@
 #  初期化ルーチン機能
 #
+
+# kernel_cfg.hの生成
+$kernelCfgH.add2("#define TNUM_INIRTN\t#{$cfgData[:ATT_INI].size}")
+
+# kernel_cfg.cの生成
 $kernelCfgC.comment_header("Initialization Routine")
 
 # エラーチェック
-$cfgData[:ATT_INI].each do |key, params|
-  # iniatrが無効の場合（E_RSATR）［NGKI3241］
+$cfgData[:ATT_INI].each do |_, params|
+  # iniatrが無効の場合（E_RSATR）［NGKI3241］［NGKI3202］［NGKI3203］
   #（TA_NULLでない場合）
   if (params[:iniatr] != $TA_NULL)
@@ -495,24 +500,35 @@
 end
 
-# 初期化ルーチンの実行関数の生成
-$kernelCfgC.append(<<EOS)
-void
-_kernel_call_inirtn(void)
-{
-EOS
-$cfgData[:ATT_INI].each do |key, params|
-  $kernelCfgC.add("\t((INIRTN)(#{params[:inirtn]}))" \
-								"((intptr_t)(#{params[:exinf]}));")
-end
-$kernelCfgC.add2("}")
+# 初期化ルーチンの数の定義
+$kernelCfgC.add2("const uint_t _kernel_tnum_inirtn = TNUM_INIRTN;");
+
+# 初期化ルーチンテーブルの生成
+if $cfgData[:ATT_INI].size > 0
+  $kernelCfgC.add("const INIRTNB _kernel_inirtnb_table[TNUM_INIRTN] = {")
+  $cfgData[:ATT_INI].each_with_index do |(_, params), index|
+    $kernelCfgC.add(",") if index > 0
+    $kernelCfgC.append("\t{ (INIRTN)(#{params[:inirtn]}), " \
+								"(intptr_t)(#{params[:exinf]}) }")
+  end
+  $kernelCfgC.add
+  $kernelCfgC.add2("};")
+else
+  $kernelCfgC.add2("TOPPERS_EMPTY_LABEL(const INIRTNB, " \
+										"_kernel_inirtnb_table);")
+end
 
 #
 #  終了処理ルーチン機能
 #
+
+# kernel_cfg.hの生成
+$kernelCfgH.add2("#define TNUM_TERRTN\t#{$cfgData[:ATT_TER].size}")
+
+# kernel_cfg.cの生成
 $kernelCfgC.comment_header("Termination Routine")
 
 # エラーチェック
-$cfgData[:ATT_TER].each do |key, params|
-  # teratrが無効の場合（E_RSATR）［NGKI3248］
+$cfgData[:ATT_TER].each do |_, params|
+  # teratrが無効の場合（E_RSATR）［NGKI3248］［NGKI3208］［NGKI3209］
   #（TA_NULLでない場合）
   if (params[:teratr] != $TA_NULL)
@@ -521,15 +537,21 @@
 end
 
-# 終了処理ルーチンの実行関数の生成
-$kernelCfgC.append(<<EOS)
-void
-_kernel_call_terrtn(void)
-{
-EOS
-$cfgData[:ATT_TER].reverse_each do |key, params|
-  $kernelCfgC.add("\t((TERRTN)(#{params[:terrtn]}))" \
-								"((intptr_t)(#{params[:exinf]}));")
-end
-$kernelCfgC.add2("}")
+# 終了処理ルーチンの数の定義
+$kernelCfgC.add2("const uint_t _kernel_tnum_terrtn = TNUM_TERRTN;");
+
+# 終了処理ルーチンテーブルの生成
+if $cfgData[:ATT_TER].size > 0
+  $kernelCfgC.add("const TERRTNB _kernel_terrtnb_table[TNUM_TERRTN] = {")
+  $cfgData[:ATT_TER].reverse_each.each_with_index do |(_, params), index|
+    $kernelCfgC.add(",") if index > 0
+    $kernelCfgC.append("\t{ (TERRTN)(#{params[:terrtn]}), " \
+								"(intptr_t)(#{params[:exinf]}) }")
+  end
+  $kernelCfgC.add
+  $kernelCfgC.add2("};")
+else
+  $kernelCfgC.add2("TOPPERS_EMPTY_LABEL(const TERRTNB, " \
+										"_kernel_terrtnb_table);")
+end
 
 #
Index: EcnlProtoTool/trunk/asp3_dcre/kernel/kernel_api.def
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/kernel/kernel_api.def	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/kernel/kernel_api.def	(revision 429)
@@ -23,5 +23,5 @@
 DEF_EXC .excno* { .excatr &exchdr }
 DEF_ICS { .istksz &istk? }
-DEF_KMM { .kmmsz &kmm? }
+DEF_MPK { .mpksz &mpk? }
 ATT_INI { .iniatr &exinf &inirtn }
 ATT_TER { .teratr &exinf &terrtn }
Index: EcnlProtoTool/trunk/asp3_dcre/kernel/kernel_check.trb
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/kernel/kernel_check.trb	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/kernel/kernel_check.trb	(revision 429)
@@ -1,4 +1,4 @@
 # -*- coding: utf-8 -*-
-# 
+#
 #   TOPPERS/ASP Kernel
 #       Toyohashi Open Platform for Embedded Real-Time Systems/
@@ -6,5 +6,5 @@
 # 
 #   Copyright (C) 2015 by FUJI SOFT INCORPORATED, JAPAN
-#   Copyright (C) 2015,2016 by Embedded and Real-Time Systems Laboratory
+#   Copyright (C) 2015-2019 by Embedded and Real-Time Systems Laboratory
 #               Graduate School of Information Science, Nagoya Univ., JAPAN
 #  
@@ -38,5 +38,5 @@
 #   の責任を負わない．
 # 
-#   $Id$
+#   $Id: kernel_check.trb 1167 2019-02-03 17:06:17Z ertl-hiro $
 #  
 
@@ -45,7 +45,7 @@
 #
 
-# 
+#
 #  タイムスタンプファイルの指定
-# 
+#
 $timeStampFileName = "check.timestamp"
 
@@ -53,5 +53,5 @@
 #  データセクションのLMAからVMAへのコピー
 #
-if !$lmaList.nil?
+if defined?($lmaList)
   $lmaList.each do |lma|
     startData = SYMBOL(lma[:START_DATA])
@@ -92,12 +92,13 @@
     # 通知処理のパラメータが2つの場合
     epar1 = params[:par3]
-    epar2 = params[:par4]
+    # epar2 = params[:par4]
   else
     # 通知処理のパラメータが1つの場合
     epar1 = params[:par2]
-    epar2 = params[:par3]
-  end
-
-  #	タイムイベントハンドラの先頭番地のチェック［NGKI3693］
+    # epar2 = params[:par3]
+  end
+
+  # タイムイベントハンドラの先頭番地が，プログラムの先頭番地として正し
+  # くない場合（E_PAR）［NGKI3693］
   if nfymode == $TNFY_HANDLER
     tmehdr = nfyhdr
@@ -112,5 +113,5 @@
   end
 
-  #	イベント通知処理の変数の番地とオブジェクトIDのチェック
+  # イベント通知処理の変数の番地とオブジェクトIDのチェック
   if nfymode1 == $TNFY_SETVAR || nfymode1 == $TNFY_INCVAR
     # 変数の設定／インクリメントによるタイムイベントの通知
@@ -119,5 +120,6 @@
     params1[:p_var] = par1
 
-    # 変数の番地のチェック［NGKI3699］［NGKI3897］
+    # 通知方法中の変数の番地が，intptr_t型の変数の番地として正しくない
+    # 場合（E_PAR）［NGKI3699］［NGKI3897］
     if (p_var & ($CHECK_INTPTR_ALIGN - 1)) != 0
       error_wrong_id("E_PAR", params1, :p_var, objid, "not aligned")
@@ -132,5 +134,5 @@
     params1[:tskid] = par1
 
-    # タスクIDのチェック［NGKI3704］
+    # 通知方法中のタスクIDが有効範囲外の場合（E_ID）［NGKI3704］
     if !($TMIN_TSKID <= tskid && tskid <= $tmax_tskid)
       error_illegal_id("E_ID", params1, :tskid, objid)
@@ -142,5 +144,5 @@
     params1[:semid] = par1
 
-    # セマフォIDのチェック［NGKI3707］
+    # 通知方法中のセマフォIDが有効範囲外の場合（E_ID）［NGKI3707］
     if !($TMIN_SEMID <= semid && semid <= $tmax_semid)
       error_illegal_id("E_ID", params1, :semid, objid)
@@ -152,5 +154,5 @@
     params1[:flgid] = par1
 
-    # イベントフラグIDのチェック［NGKI3710］
+    # 通知方法中のイベントフラグIDが有効範囲外の場合（E_ID）［NGKI3710］
     if !($TMIN_FLGID <= flgid && flgid <= $tmax_flgid)
       error_illegal_id("E_ID", params1, :flgid, objid)
@@ -162,5 +164,5 @@
     params1[:dtqid] = par1
 
-    # データキューIDのチェック［NGKI3713］
+    # 通知方法中のデータキューIDが有効範囲外の場合（E_ID）［NGKI3713］
     if !($TMIN_DTQID <= dtqid && dtqid <= $tmax_dtqid)
       error_illegal_id("E_ID", params1, :dtqid, objid)
@@ -175,5 +177,6 @@
     params1[:p_var] = epar1
 
-    # 変数の番地のチェック［NGKI3701］［NGKI3897］
+    # 通知方法中の変数の番地が，intptr_t型の変数の番地として正しくない
+    # 場合（E_PAR）［NGKI3701］［NGKI3897］
     if (p_var & ($CHECK_INTPTR_ALIGN - 1)) != 0
       error_wrong_id("E_PAR", params1, :p_var, objid, "not aligned")
@@ -188,5 +191,5 @@
     params1[:tskid] = epar1
 
-    # タスクIDのチェック［NGKI3704］
+    # 通知方法中のタスクIDが有効範囲外の場合（E_ID）［NGKI3704］
     if !($TMIN_TSKID <= tskid && tskid <= $tmax_tskid)
       error_illegal_id("E_ID", params1, :tskid, objid)
@@ -198,5 +201,5 @@
     params1[:semid] = epar1
 
-    # セマフォIDのチェック［NGKI3707］
+    # 通知方法中のセマフォIDが有効範囲外の場合（E_ID）［NGKI3707］
     if !($TMIN_SEMID <= semid && semid <= $tmax_semid)
       error_illegal_id("E_ID", params1, :semid, objid)
@@ -208,5 +211,5 @@
     params1[:flgid] = epar1
 
-    # イベントフラグIDのチェック［NGKI3710］
+    # 通知方法中のイベントフラグIDが有効範囲外の場合（E_ID）［NGKI3710］
     if !($TMIN_FLGID <= flgid && flgid <= $tmax_flgid)
       error_illegal_id("E_ID", params1, :flgid, objid)
@@ -218,5 +221,5 @@
     params1[:dtqid] = epar1
 
-    # データキューIDのチェック［NGKI3715］
+    # 通知方法中のデータキューIDが有効範囲外の場合（E_ID）［NGKI3715］
     if !($TMIN_DTQID <= dtqid && dtqid <= $tmax_dtqid)
       error_illegal_id("E_ID", params1, :dtqid, objid)
@@ -225,12 +228,11 @@
 end
 
-# 
+#
 #  タスクに関するチェック
-# 
+#
 tinib = SYMBOL("_kernel_tinib_table")
 $cfgData[:CRE_TSK].sort.each do |key, params|
+  # taskがプログラムの先頭番地として正しくない場合（E_PAR）［NGKI1033］
   task = PEEK(tinib + $offsetof_TINIB_task, $sizeof_TASK)
-
-  # タスクの先頭番地のチェック［NGKI1033］
   if (task & ($CHECK_FUNC_ALIGN - 1)) != 0
     error_wrong_id("E_PAR", params, :task, :tskid, "not aligned")
@@ -240,5 +242,5 @@
   end
 
-  # タスクのスタック領域の先頭番地のチェック［NGKI1056］
+  # stkがターゲット定義の制約に合致しない場合（E_PAR）［NGKI1056］
   if $USE_TSKINICTXB
     stk = GetStackTskinictxb(key, params, tinib)
@@ -256,12 +258,12 @@
 end
 
-# 
+#
 #  固定長メモリプールに関するチェック
-# 
+#
 mpfinib = SYMBOL("_kernel_mpfinib_table")
-$cfgData[:CRE_MPF].sort.each do |key, params|
+$cfgData[:CRE_MPF].sort.each do |_, params|
   mpf = PEEK(mpfinib + $offsetof_MPFINIB_mpf, $sizeof_void_ptr)
 
-  # 固定長メモリプール領域の先頭番地のチェック［NGKI2249］
+  # mpfがターゲット定義の制約に合致しない場合（E_PAR）［NGKI2249］
   if (mpf & ($CHECK_MPF_ALIGN - 1)) != 0
     error_wrong_id("E_PAR", params, :mpf, :mpfid, "not aligned")
@@ -274,7 +276,7 @@
 end
 
-# 
+#
 #  周期通知に関するチェック
-# 
+#
 cycinib = SYMBOL("_kernel_cycinib_table")
 $cfgData[:CRE_CYC].sort.each do |key, params|
@@ -282,5 +284,5 @@
   nfyhdr = PEEK(cycinib + $offsetof_CYCINIB_nfyhdr, $sizeof_NFYHDR)
 
-  #	通知情報のチェック
+  # 通知情報のチェック
   checkNotifyHandler(key, params, :cycid, exinf, nfyhdr)
 
@@ -288,7 +290,7 @@
 end
 
-# 
+#
 #  アラーム通知に関するチェック
-# 
+#
 alminib = SYMBOL("_kernel_alminib_table")
 $cfgData[:CRE_ALM].sort.each do |key, params|
@@ -296,5 +298,5 @@
   nfyhdr = PEEK(alminib + $offsetof_ALMINIB_nfyhdr, $sizeof_NFYHDR)
 
-  #	通知情報のチェック
+  # 通知情報のチェック
   checkNotifyHandler(key, params, :almid, exinf, nfyhdr)
 
@@ -306,8 +308,8 @@
 #
 isrinib = SYMBOL("_kernel_isrinib_table")
-$cfgData[:CRE_ISR].sort.each do |key, params|
+$cfgData[:CRE_ISR].sort.each do |_, params|
   isr = PEEK(isrinib + $offsetof_ISRINIB_isr, $sizeof_ISR)
 
-  # 割込みサービスルーチンの先頭番地のチェック［NGKI3004］
+  # isrがプログラムの先頭番地として正しくない場合［NGKI3004］
   if (isr & ($CHECK_FUNC_ALIGN - 1)) != 0
     error_wrong_id("E_PAR", params, :isr, :isrid, "not aligned")
@@ -320,30 +322,69 @@
 end
 
-# 
+#
 #  非タスクコンテキスト用のスタック領域に関するチェック
-# 
-istkAddr = SYMBOL("_kernel_istk")
-if !istkAddr.nil?
-  istk = PEEK(istkAddr, $sizeof_void_ptr)
-
-  # 非タスクコンテキスト用のスタック領域の先頭番地のチェック［NGKI3222］
+#
+if $cfgData[:DEF_ICS].size > 0
+  params0 = $cfgData[:DEF_ICS][1]
+  istk = PEEK(SYMBOL("_kernel_istk"), $sizeof_void_ptr)
+
+  # istkがターゲット定義の制約に合致しない場合（E_PAR）［NGKI3222］
   if (istk & ($CHECK_STACK_ALIGN - 1)) != 0
-    error_wrong("E_PAR", $cfgData[:DEF_ICS][1], :istk, "not aligned")
+    error_wrong("E_PAR", params0, :istk, "not aligned")
   end
   if $CHECK_STACK_NONNULL && istk == 0
-    error_wrong("E_PAR", $cfgData[:DEF_ICS][1], :istk, "null")
-  end
-end
-
-# 
-#  カーネルが割り付けるメモリ領域に関するチェック
-# 
-kmmAddr = SYMBOL("_kernel_kmm")
-if !kmmAddr.nil?
-  kmm = PEEK(kmmAddr, $sizeof_void_ptr)
-
-  # カーネルが割り付けるメモリ領域の先頭番地のチェック
-  if (kmm & ($CHECK_MB_ALIGN - 1)) != 0
-    error_wrong("E_PAR", $cfgData[:DEF_KMM][1], :kmm, "not aligned")
-  end
-end
+    error_wrong("E_PAR", params0, :istk, "null")
+  end
+end
+
+#
+#  カーネルメモリプール領域に関するチェック
+#
+if $cfgData[:DEF_MPK].size > 0
+  params0 = $cfgData[:DEF_MPK][1]
+  mpk = PEEK(SYMBOL("_kernel_mpk"), $sizeof_void_ptr)
+
+  # mpkがターゲット定義の制約に合致しない場合（E_PAR）［NGKI5083］
+  if (mpk & ($CHECK_MPK_ALIGN - 1)) != 0
+    error_wrong("E_PAR", params0, :mpk, "not aligned")
+  end
+  if $CHECK_MPK_NONNULL && mpk == 0
+    error_wrong("E_PAR", params0, :mpk, "null")
+  end
+end
+
+#
+#  初期化ルーチンに関するチェック
+#
+inirtnb = SYMBOL("_kernel_inirtnb_table")
+$cfgData[:ATT_INI].each do |_, params|
+  inirtn = PEEK(inirtnb + $offsetof_INIRTNB_inirtn, $sizeof_INIRTN)
+
+  # inirtnがプログラムの先頭番地として正しくない場合（E_PAR）［NGKI3243］
+  if (inirtn & ($CHECK_FUNC_ALIGN - 1)) != 0
+    error_wrong("E_PAR", params, :inirtn, "not aligned")
+  end
+  if $CHECK_FUNC_NONNULL && inirtn == 0
+    error_wrong("E_PAR", params, :inirtn, "null")
+  end
+
+  inirtnb += $sizeof_INIRTNB
+end
+
+#
+#  終了処理ルーチンに関するチェック
+#
+terrtnb = SYMBOL("_kernel_terrtnb_table")
+$cfgData[:ATT_TER].each do |_, params|
+  terrtn = PEEK(terrtnb + $offsetof_TERRTNB_terrtn, $sizeof_TERRTN)
+
+  # terrtnがプログラムの先頭番地として正しくない場合（E_PAR）［NGKI3250］
+  if (terrtn & ($CHECK_FUNC_ALIGN - 1)) != 0
+    error_wrong("E_PAR", params, :terrtn, "not aligned")
+  end
+  if $CHECK_FUNC_NONNULL && terrtn == 0
+    error_wrong("E_PAR", params, :terrtn, "null")
+  end
+
+  terrtnb += $sizeof_TERRTNB
+end
Index: EcnlProtoTool/trunk/asp3_dcre/kernel/kernel_impl.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/kernel/kernel_impl.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/kernel/kernel_impl.h	(revision 429)
@@ -6,5 +6,5 @@
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2004-2016 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2004-2018 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -71,9 +71,9 @@
 
 /*
- *  型キャストを行うマクロの定義
- */
-#ifndef CAST
-#define CAST(type, val)		((type)(val))
-#endif /* CAST */
+ *  トレースログに関する設定
+ */
+#ifdef TOPPERS_ENABLE_TRACE
+#include "arch/tracelog/trace_log.h"
+#endif /* TOPPERS_ENABLE_TRACE */
 
 /*
@@ -157,4 +157,8 @@
 #endif /* TARGET_ISRATR */
 
+#ifndef TARGET_MIN_STKSZ			/* タスクのスタックサイズの最小値 */
+#define TARGET_MIN_STKSZ	1U		/* 未定義の場合は0でないことをチェック */
+#endif /* TARGET_MIN_STKSZ */
+
 /*
  *  ヘッダファイルを持たないモジュールの関数・変数の宣言
@@ -173,12 +177,26 @@
 
 /*
- *  初期化ルーチンの実行（kernel_cfg.c）
- */
-extern void	call_inirtn(void);
-
-/*
- *  終了処理ルーチンの実行（kernel_cfg.c）
- */
-extern void	call_terrtn(void);
+ *  初期化ルーチン関係の定義（kernel_cfg.c）
+ */
+typedef struct initialization_routine_block {
+	INIRTN		inirtn;					/* 初期化ルーチンの先頭番地 */
+	intptr_t	exinf;					/* 初期化ルーチンの拡張情報 */
+} INIRTNB;
+
+extern const uint_t	tnum_inirtn;		/* 初期化ルーチンの数 */
+
+extern const INIRTNB inirtnb_table[];	/* 初期化ルーチンブロックテーブル */
+
+/*
+ *  終了処理ルーチン関係の定義（kernel_cfg.c）
+ */
+typedef struct termination_routine_block {
+	TERRTN		terrtn;					/* 終了処理ルーチンの先頭番地 */
+	intptr_t	exinf;					/* 終了処理ルーチンの拡張情報 */
+} TERRTNB;
+
+extern const uint_t	tnum_terrtn;		/* 終了処理ルーチンの数 */
+
+extern const TERRTNB terrtnb_table[];	/* 終了処理ルーチンブロックテーブル */
 
 /*
@@ -192,8 +210,8 @@
 
 /*
- *  カーネルが割り付けるメモリ領域（kernel_cfg.c）
- */
-extern const size_t	kmmsz;		/* カーネルが割り付けるメモリ領域のサイズ */
-extern MB_T *const	kmm;		/* カーネルが割り付けるメモリ領域の先頭番地 */
+ *  カーネルメモリプール領域（kernel_cfg.c）
+ */
+extern const size_t	mpksz;		/* カーネルメモリプール領域のサイズ */
+extern MB_T *const	mpk;		/* カーネルメモリプール領域の先頭番地 */
 
 /*
@@ -203,4 +221,9 @@
 
 /*
+ *  カーネルメモリプール領域有効フラグ（startup.c）
+ */
+extern bool_t	mpk_valid;
+
+/*
  *  カーネルの起動（startup.c）
  */
@@ -213,9 +236,31 @@
 
 /*
- *  カーネルの割り付けるメモリ領域の管理（startup.c）
- */
-extern void initialize_kmm(void);
-extern void *kernel_malloc(size_t size);
-extern void kernel_free(void *ptr);
+ *  メモリプール領域の管理（startup.c）
+ */
+extern bool_t initialize_mempool(MB_T *mempool, size_t size);
+extern void *malloc_mempool(MB_T *mempool, size_t size);
+extern void free_mempool(MB_T *mempool, void *ptr);
+
+/*
+ *  カーネルメモリプール領域からのメモリ獲得／解放
+ */
+Inline void *
+malloc_mpk(size_t size)
+{
+	if (mpk_valid) {
+		return(malloc_mempool(mpk, size));
+	}
+	else {
+		return(NULL);
+	}
+}
+
+Inline void
+free_mpk(void *ptr)
+{
+	if (mpk_valid) {
+		free_mempool(mpk, ptr);
+	}
+}
 
 /*
@@ -225,10 +270,10 @@
 
 /*
- *  通知方法のエラーチェック
+ *  通知方法のエラーチェック（time_manage.c）
  */
 extern ER check_nfyinfo(const T_NFYINFO *p_nfyinfo);
 
 /*
- *  通知ハンドラ
+ *  通知ハンドラ（time_manage.c）
  */
 extern void notify_handler(intptr_t exinf);
Index: EcnlProtoTool/trunk/asp3_dcre/kernel/kernel_rename.def
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/kernel/kernel_rename.def	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/kernel/kernel_rename.def	(revision 429)
@@ -1,8 +1,9 @@
 # startup.c
 kerflg
+mpk_valid
 exit_kernel
-initialize_kmm
-kernel_malloc
-kernel_free
+initialize_mempool
+malloc_mempool
+free_mempool
 
 # task.c
@@ -51,5 +52,5 @@
 set_hrt_event
 tmevtb_register
-tmevtb_enqueue
+tmevtb_enqueue_reltim
 tmevtb_dequeue
 check_adjtim
@@ -124,6 +125,8 @@
 # kernel_cfg.c
 initialize_object
-call_inirtn
-call_terrtn
+tnum_inirtn
+inirtnb_table
+tnum_terrtn
+terrtnb_table
 tmax_tskid
 tmax_stskid
@@ -193,6 +196,14 @@
 istk
 istkpt
-kmmsz
-kmm
+mpksz
+mpk
+
+# tTraceLog.c
+log_dsp_enter
+log_dsp_leave
+log_inh_enter
+log_inh_leave
+log_exc_enter
+log_exc_leave
 
 INCLUDE "target"
Index: EcnlProtoTool/trunk/asp3_dcre/kernel/kernel_rename.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/kernel/kernel_rename.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/kernel/kernel_rename.h	(revision 429)
@@ -8,8 +8,9 @@
  */
 #define kerflg						_kernel_kerflg
+#define mpk_valid					_kernel_mpk_valid
 #define exit_kernel					_kernel_exit_kernel
-#define initialize_kmm				_kernel_initialize_kmm
-#define kernel_malloc				_kernel_kernel_malloc
-#define kernel_free					_kernel_kernel_free
+#define initialize_mempool			_kernel_initialize_mempool
+#define malloc_mempool				_kernel_malloc_mempool
+#define free_mempool				_kernel_free_mempool
 
 /*
@@ -66,5 +67,5 @@
 #define set_hrt_event				_kernel_set_hrt_event
 #define tmevtb_register				_kernel_tmevtb_register
-#define tmevtb_enqueue				_kernel_tmevtb_enqueue
+#define tmevtb_enqueue_reltim		_kernel_tmevtb_enqueue_reltim
 #define tmevtb_dequeue				_kernel_tmevtb_dequeue
 #define check_adjtim				_kernel_check_adjtim
@@ -163,6 +164,8 @@
  */
 #define initialize_object			_kernel_initialize_object
-#define call_inirtn					_kernel_call_inirtn
-#define call_terrtn					_kernel_call_terrtn
+#define tnum_inirtn					_kernel_tnum_inirtn
+#define inirtnb_table				_kernel_inirtnb_table
+#define tnum_terrtn					_kernel_tnum_terrtn
+#define terrtnb_table				_kernel_terrtnb_table
 #define tmax_tskid					_kernel_tmax_tskid
 #define tmax_stskid					_kernel_tmax_stskid
@@ -232,6 +235,16 @@
 #define istk						_kernel_istk
 #define istkpt						_kernel_istkpt
-#define kmmsz						_kernel_kmmsz
-#define kmm							_kernel_kmm
+#define mpksz						_kernel_mpksz
+#define mpk							_kernel_mpk
+
+/*
+ *  tTraceLog.c
+ */
+#define log_dsp_enter				_kernel_log_dsp_enter
+#define log_dsp_leave				_kernel_log_dsp_leave
+#define log_inh_enter				_kernel_log_inh_enter
+#define log_inh_leave				_kernel_log_inh_leave
+#define log_exc_enter				_kernel_log_exc_enter
+#define log_exc_leave				_kernel_log_exc_leave
 
 
Index: EcnlProtoTool/trunk/asp3_dcre/kernel/kernel_sym.def
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/kernel/kernel_sym.def	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/kernel/kernel_sym.def	(revision 429)
@@ -1,5 +1,3 @@
-USE_EXTERNAL_ID,true,bool,defined(USE_EXTERNAL_ID)
-SIL_ENDIAN_BIG,true,bool,defined(SIL_ENDIAN_BIG)
-SIL_ENDIAN_LITTLE,true,bool,defined(SIL_ENDIAN_LITTLE)
+USE_EXTERNAL_ID,true,bool,defined(USE_EXTERNAL_ID),false
 TA_NULL
 TA_ACT
@@ -48,26 +46,28 @@
 TMIN_CYCID,,signed
 TMIN_ALMID,,signed
-USE_TSKINICTXB,true,bool,defined(USE_TSKINICTXB)
-OMIT_INITIALIZE_INTERRUPT,true,bool,defined(OMIT_INITIALIZE_INTERRUPT)
-USE_INHINIB_TABLE,true,bool,defined(USE_INHINIB_TABLE)
-USE_INTINIB_TABLE,true,bool,defined(USE_INTINIB_TABLE)
-OMIT_INITIALIZE_EXCEPTION,true,bool,defined(OMIT_INITIALIZE_EXCEPTION)
-DEFAULT_ISTK,,,defined(DEFAULT_ISTK)
-TARGET_TSKATR,,,defined(TARGET_TSKATR),0
+USE_TSKINICTXB,true,bool,defined(USE_TSKINICTXB),false
+OMIT_INITIALIZE_INTERRUPT,true,bool,defined(OMIT_INITIALIZE_INTERRUPT),false
+USE_INHINIB_TABLE,true,bool,defined(USE_INHINIB_TABLE),false
+USE_INTINIB_TABLE,true,bool,defined(USE_INTINIB_TABLE),false
+OMIT_INITIALIZE_EXCEPTION,true,bool,defined(OMIT_INITIALIZE_EXCEPTION),false
+DEFAULT_ISTK,,intptr,defined(DEFAULT_ISTK)
+TARGET_TSKATR
 TARGET_INTATR,,,defined(TARGET_INTATR),0
 TARGET_INHATR,,,defined(TARGET_INHATR),0
-TARGET_ISRATR,,,defined(TARGET_ISRATR),0
+TARGET_ISRATR
 TARGET_EXCATR,,,defined(TARGET_EXCATR),0
-TARGET_MIN_STKSZ,,,defined(TARGET_MIN_STKSZ),1
+TARGET_MIN_STKSZ
 TARGET_MIN_ISTKSZ,,,defined(TARGET_MIN_ISTKSZ),1
 CHECK_STKSZ_ALIGN,,,defined(CHECK_STKSZ_ALIGN),1
 CHECK_INTPTR_ALIGN,,,defined(CHECK_INTPTR_ALIGN),1
-CHECK_INTPTR_NONNULL,true,bool,defined(CHECK_INTPTR_NONNULL)
+CHECK_INTPTR_NONNULL,true,bool,defined(CHECK_INTPTR_NONNULL),false
 CHECK_FUNC_ALIGN,,,defined(CHECK_FUNC_ALIGN),1
-CHECK_FUNC_NONNULL,true,bool,defined(CHECK_FUNC_NONNULL)
+CHECK_FUNC_NONNULL,true,bool,defined(CHECK_FUNC_NONNULL),false
 CHECK_STACK_ALIGN,,,defined(CHECK_STACK_ALIGN),1
-CHECK_STACK_NONNULL,true,bool,defined(CHECK_STACK_NONNULL)
+CHECK_STACK_NONNULL,true,bool,defined(CHECK_STACK_NONNULL),false
 CHECK_MPF_ALIGN,,,defined(CHECK_MPF_ALIGN),1
-CHECK_MPF_NONNULL,true,bool,defined(CHECK_MPF_NONNULL)
+CHECK_MPF_NONNULL,true,bool,defined(CHECK_MPF_NONNULL),false
+CHECK_MPK_ALIGN,,,defined(CHECK_MPK_ALIGN),1
+CHECK_MPK_NONNULL,true,bool,defined(CHECK_MPK_NONNULL),false
 CHECK_MB_ALIGN,,,defined(CHECK_MB_ALIGN),1
 sizeof_void_ptr,sizeof(void*)
@@ -138,13 +138,19 @@
 offsetof_ISRINIB_isrpri,"offsetof(ISRINIB,isrpri)"
 sizeof_INHINIB,sizeof(INHINIB),,!defined(OMIT_INITIALIZE_INTERRUPT)
-offset_INHINIB_inhno,"offsetof(INHINIB,inhno)",,!defined(OMIT_INITIALIZE_INTERRUPT)
-offset_INHINIB_inhatr,"offsetof(INHINIB,inhatr)",,!defined(OMIT_INITIALIZE_INTERRUPT),,
-offset_INHINIB_int_entry,"offsetof(INHINIB,int_entry)",,!defined(OMIT_INITIALIZE_INTERRUPT),,
+offsetof_INHINIB_inhno,"offsetof(INHINIB,inhno)",,!defined(OMIT_INITIALIZE_INTERRUPT)
+offsetof_INHINIB_inhatr,"offsetof(INHINIB,inhatr)",,!defined(OMIT_INITIALIZE_INTERRUPT),,
+offsetof_INHINIB_int_entry,"offsetof(INHINIB,int_entry)",,!defined(OMIT_INITIALIZE_INTERRUPT),,
 sizeof_INTINIB,sizeof(INTINIB),,!defined(OMIT_INITIALIZE_INTERRUPT)
-offset_INTINIB_intno,"offsetof(INTINIB,intno)",,!defined(OMIT_INITIALIZE_INTERRUPT)
-offset_INTINIB_intatr,"offsetof(INTINIB,intatr)",,!defined(OMIT_INITIALIZE_INTERRUPT)
-offset_INTINIB_intpri,"offsetof(INTINIB,intpri)",,!defined(OMIT_INITIALIZE_INTERRUPT)
+offsetof_INTINIB_intno,"offsetof(INTINIB,intno)",,!defined(OMIT_INITIALIZE_INTERRUPT)
+offsetof_INTINIB_intatr,"offsetof(INTINIB,intatr)",,!defined(OMIT_INITIALIZE_INTERRUPT)
+offsetof_INTINIB_intpri,"offsetof(INTINIB,intpri)",,!defined(OMIT_INITIALIZE_INTERRUPT)
 sizeof_EXCINIB,sizeof(EXCINIB),,!defined(OMIT_INITIALIZE_EXCEPTION)
-offset_EXCINIB_excno,"offsetof(EXCINIB,excno)",,!defined(OMIT_INITIALIZE_EXCEPTION)
-offset_EXCINIB_excatr,"offsetof(EXCINIB,excatr)",,!defined(OMIT_INITIALIZE_EXCEPTION)
-offset_EXCINIB_exc_entry,"offsetof(EXCINIB,exc_entry)",,!defined(OMIT_INITIALIZE_EXCEPTION)
+offsetof_EXCINIB_excno,"offsetof(EXCINIB,excno)",,!defined(OMIT_INITIALIZE_EXCEPTION)
+offsetof_EXCINIB_excatr,"offsetof(EXCINIB,excatr)",,!defined(OMIT_INITIALIZE_EXCEPTION)
+offsetof_EXCINIB_exc_entry,"offsetof(EXCINIB,exc_entry)",,!defined(OMIT_INITIALIZE_EXCEPTION)
+sizeof_INIRTNB,sizeof(INIRTNB)
+offsetof_INIRTNB_inirtn,"offsetof(INIRTNB,inirtn)"
+offsetof_INIRTNB_exinf,"offsetof(INIRTNB,exinf)"
+sizeof_TERRTNB,sizeof(TERRTNB)
+offsetof_TERRTNB_terrtn,"offsetof(TERRTNB,terrtn)"
+offsetof_TERRTNB_exinf,"offsetof(TERRTNB,exinf)"
Index: EcnlProtoTool/trunk/asp3_dcre/kernel/kernel_unrename.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/kernel/kernel_unrename.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/kernel/kernel_unrename.h	(revision 429)
@@ -9,8 +9,9 @@
  */
 #undef kerflg
+#undef mpk_valid
 #undef exit_kernel
-#undef initialize_kmm
-#undef kernel_malloc
-#undef kernel_free
+#undef initialize_mempool
+#undef malloc_mempool
+#undef free_mempool
 
 /*
@@ -67,5 +68,5 @@
 #undef set_hrt_event
 #undef tmevtb_register
-#undef tmevtb_enqueue
+#undef tmevtb_enqueue_reltim
 #undef tmevtb_dequeue
 #undef check_adjtim
@@ -164,6 +165,8 @@
  */
 #undef initialize_object
-#undef call_inirtn
-#undef call_terrtn
+#undef tnum_inirtn
+#undef inirtnb_table
+#undef tnum_terrtn
+#undef terrtnb_table
 #undef tmax_tskid
 #undef tmax_stskid
@@ -233,6 +236,16 @@
 #undef istk
 #undef istkpt
-#undef kmmsz
-#undef kmm
+#undef mpksz
+#undef mpk
+
+/*
+ *  tTraceLog.c
+ */
+#undef log_dsp_enter
+#undef log_dsp_leave
+#undef log_inh_enter
+#undef log_inh_leave
+#undef log_exc_enter
+#undef log_exc_leave
 
 
